Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/installer-simple/bin/alxinstall-ng.sh.in revision 2320 by niro, Fri Jan 3 13:12:33 2014 UTC trunk/installer-simple/bin/installer.sh.in revision 2399 by niro, Tue Jan 7 13:13:26 2014 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/bash
2    # $Id$
3  #  #
4  # $Header: /home/cvsd/alx-cvs/alx-src/alxinstall-ng/bin/alxinstall-ng.sh,v 1.15 2008-06-28 00:37:45 niro Exp $  # Simple Installation Script
5  #  # merged from alxinstall-ng and mcore-installer
 # AutoSta_LX Installation Script  
6  #  #
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
 # <rogalla@augusta-bochum.de>  
 #  
 #  
 # Install Navigation Gui  
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # ignore the environment
11  source /mnt/cdrom/system/images.conf  LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /usr/lib/alxinstall-ng/functions/findhdd.sh > /dev/null  # -> now in images.conf
17  ### bugfix ###############################  CURRENTLINE=0
18  cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
19  ########################################  die()
20    {
21     echo "Error: $@"
22     exit 1
23    }
24    
25    # configuration
26    if [ -e %SYSCONFDIR%/installer.conf ]
27    then
28     source %SYSCONFDIR%/installer.conf
29    else
30     die "/etc/installer.conf not found"
31    fi
32    
33    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
34    # -> now in images.conf
35    CDIMAGENAME=""
36    TOTALLINES=""
37    CURRENTLINE=0
38    if [ -e /mnt/cdrom/system/images.conf ]
39    then
40     source /mnt/cdrom/system/images.conf
41     # check if all required variables are set
42     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
43     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
44    else
45     die "/mnt/cdrom/system/images.conf not found"
46    fi
47    
48    # includes
49    source ${INSTALLER_LIBDIR}/functions/hwdetection.sh
50    
51  ### System/Config Version  ### System/Config Version
52  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
53  TITLE="alxinstall-ng - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
54    
55  CDPATH="/mnt/cdrom"  CDROOT="${DEFAULT_CDROOT}"
56  INSTALLPATH="/mnt/magellan"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
   
 ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  
 CURRENTLINE=0  
 #TOTALLINES=11072 # -> now in images.conf  
57    
58  # standard kernel opts  # standard kernel opts
59  KERNELOPTS="quiet video=1024x768"  KERNELOPTS="quiet video=1024x768"
# Line 46  SPECIALDEVICE="" Line 70  SPECIALDEVICE=""
70  FORMFACTOR="desktop"  FORMFACTOR="desktop"
71    
72  # target filesystem  # target filesystem
73  FORMAT_FILESYSTEM="ext4"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
74    
75  #################################################  #################################################
76  #  DIALOG BOXEN #  #  DIALOG BOXEN #
77  #################################################  #################################################
78    
79  die()  dialog_die()
80  {  {
81   ERROR=$1   ERROR="$1"
82   RETVAL=$?   RETVAL="$?"
83   dialog_install_failure   dialog_install_failure
84   exit 1   exit 1
85  }  }
86    
87  dialog_warning()  dialog_warning()
88  {  {
89   dialog \   local retval
90   --backtitle "${TITLE}" \  
91   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
92   --defaultno \   retval=$?
93   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
94   then   then
95   clear   clear
96   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
97   exit 1   exit 1
98   fi   fi
99  }  }
100    
101  dialog_setup_hdd_info()  dialog_setup_hdd_info()
102  {  {
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
103   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="$(echo $HDD | sed 's/\/dev\///')"
104    
105   dialog \   dialog \
# Line 137  dialog_setup_system_menu() Line 141  dialog_setup_system_menu()
141   "" "" \   "" "" \
142   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
143   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
144   RES=$?   RES=$?
145   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
146   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
147   then   then
148   case "${i}" in   case "${i}" in
149   "1") run_install_auto ;;   "1") run_install_auto ;;
150           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
151   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
152   esac   esac
153   fi   fi
# Line 156  dialog_hardware_detection() Line 158  dialog_hardware_detection()
158   local i   local i
159   local hwtmp   local hwtmp
160    
161   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
162   then   then
163   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
164   else   else
165   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
166   fi   fi
167    
168   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
169    
170   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
171   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 173  dialog_hardware_detection() Line 175  dialog_hardware_detection()
175   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
176   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
177    
178   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
179   then   then
180   for i in ${scsidisks}   for i in ${ALL_DISKS}
181   do   do
182   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
183   done   done
184   fi   fi
185    
186   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
187   then   then
188   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
189     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
190     for i in ${ALL_CDROMS}
191   do   do
192   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
193   done   done
194   fi   fi
195    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
196   # other devices   # other devices
197   run_hardware_detection   run_hardware_detection
198   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 266  dialog_setup_hdd_partitions_manuell() Line 255  dialog_setup_hdd_partitions_manuell()
255   fi   fi
256  }  }
257    
258  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
259  {  {
260   local i   local i
261    
# Line 298  dialog_setup_hdd_partitions_manuell_flas Line 287  dialog_setup_hdd_partitions_manuell_flas
287   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
288   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
289   then   then
290   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
291   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
292     setup_hdd_partitions_auto
293   fi   fi
294   fi   fi
295  }  }
296    
297  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
298  {  {
299   local i   local bootdev
300    
301   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
302     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
303     # remove the boot device from ALL_DISKS if it was an usbstick
304     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
305   then   then
306   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
307   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
308   fi   fi
309     export ALL_CDROMS="$(get_hwinfo cdrom)"
310  }  }
311    
312  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 431  dialog_main() Line 397  dialog_main()
397   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
398   then   then
399   case ${METHOD} in   case ${METHOD} in
400           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
401   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
402   "3") install_do_reboot ;;   "3") install_do_reboot ;;
403   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 505  hdd_size_below_256mb() Line 471  hdd_size_below_256mb()
471   local hdd="$1"   local hdd="$1"
472   local size   local size
473   local retval   local retval
474   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
475    
476   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
477   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 534  setup_hdd_partitions_auto() Line 500  setup_hdd_partitions_auto()
500   fi   fi
501    
502   ## delete disk   ## delete disk
503   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
504    
505   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
506   then   then
# Line 582  EOF Line 548  EOF
548    
549  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
550  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
551   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
552    
553   ## hdds partitionieren manuell   ## hdds partitionieren manuell
554   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
555  }  }
556    
557  setup_hdd_format()  setup_hdd_format()
558  {  {
559   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
560  }  }
561    
562  install_mount_rootfs()  install_mount_rootfs()
563  {  {
564   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
565   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
566   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
567  }  }
568    
569  install_system_image()  install_system_image()
570  {  {
571   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
572  }  }
573    
574  install_bootsector_chroot()  install_bootsector_chroot()
575  {  {
576   local my_roothdd   local my_roothdd
577   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
578   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
579    
580   # check for grub2   # check for grub2
581   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
582   then   then
583   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
584   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
585   then   then
586   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
587   fi   fi
588    
589   # set kernelopts   # set kernelopts
590   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
591   then   then
592   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
593   else   else
594   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
595   fi   fi
596   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
597   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
598   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
599   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
600    
601   # grub-legacy   # grub-legacy
602   else   else
603   ### grubconf schreiben   ### grubconf schreiben
604   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
605    
606   #for alx only   #for alx only
607   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
608   then   then
609   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
610   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
611   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
612   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
613   fi   fi
# Line 684  install_bootsector_chroot() Line 624  install_bootsector_chroot()
624   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
625   fi   fi
626    
627   : > ${grubconf} || die   : > ${grubconf} || dialog_die
628   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
629   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
630   # using current root password   # using current root password
631   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
632    
633   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
634   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
635   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
636   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
637   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
638   if is_initrd_supported   if is_initrd_supported
639   then   then
640   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
641   fi   fi
642    
643   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
644   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
645   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
646   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
647   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
648   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
649   if is_initrd_supported   if is_initrd_supported
650   then   then
651   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
652   fi   fi
653    
654   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
655   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
656   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
657   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
658   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
659   if is_initrd_supported   if is_initrd_supported
660   then   then
661   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
662   fi   fi
663    
664   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
665   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
666  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
667  root (hd0,0)  root (hd0,0)
668  setup (hd0)  setup (hd0)
# Line 732  exit 0 Line 672  exit 0
672  CHROOTEOF  CHROOTEOF
673   fi   fi
674    
675   ## enters chroot   ## enter chroot
676   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
677   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
678   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
679   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
680   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
681   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
682   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
683   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
684  }  }
685    
686  is_initrd_supported()  is_initrd_supported()
687  {  {
688   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
689   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
690   return 1   return 1
691  }  }
692    
# Line 777  install_initrd_chroot() Line 717  install_initrd_chroot()
717   fi   fi
718    
719   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
720   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
721   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
722    
723   # install an appropriate viafb.conf   # install an appropriate viafb.conf
724   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
725    
726   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
727   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
728    
729   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
730  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
731  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
732  exit 0  exit 0
733  CHROOTEOF  CHROOTEOF
734    
735   ## enters chroot   ## enters chroot
736   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
737   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
738   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
739   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
740   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
741   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
742   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
743   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
744  }  }
745    
746  is_uuid_supported()  is_uuid_supported()
747  {  {
748   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
749   then   then
750   # only detect uuids if supported   # only detect uuids if supported
751   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 824  get_uuid() Line 764  get_uuid()
764   local TYPE   local TYPE
765    
766   local dev="$1"   local dev="$1"
767   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
768    
769   # check if given device is already an UUID   # check if given device is already an UUID
770   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 841  install_system_settings() Line 781  install_system_settings()
781   # schreibe fstab   # schreibe fstab
782   if is_uuid_supported   if is_uuid_supported
783   then   then
784   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
785   else   else
786   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
787   fi   fi
788   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
789   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
790   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
791   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
792    
793   # install network config skeleton   # install network config skeleton
794   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
795    
796   # intel framebufer quirk   # intel framebufer quirk
797   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 863  install_system_settings() Line 801  install_system_settings()
801   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
802   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
803   then   then
804   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
805   fi   fi
806   fi   fi
807   fi   fi
808  }  }
809    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
810  install_umount_rootfs()  install_umount_rootfs()
811  {  {
812   cd /   cd /
813   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
814   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
815  }  }
816    
817  install_do_reboot()  install_do_reboot()
# Line 927  run_install_normal() Line 845  run_install_normal()
845   dialog_install_successful   dialog_install_successful
846  }  }
847    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
848  run_install_auto()  run_install_auto()
849  {  {
850   dialog_hardware_detection   dialog_hardware_detection
851    
852   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
853   dialog_setup_hdd_format   dialog_setup_hdd_format
854   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
855   install_mount_rootfs_flash   install_mount_rootfs
856   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
857    
858   dialog_install_settings   dialog_install_settings
859   sleep 1   sleep 1
860   install_system_settings_flash   install_system_settings
861   install_initrd_chroot   install_initrd_chroot
862    
863   dialog_install_bootsector   dialog_install_bootsector
864   install_bootsector_chroot   install_bootsector_chroot
865    
866   install_umount_rootfs_flash   install_umount_rootfs
867   dialog_install_successful   dialog_install_successful
868  }  }
869    

Legend:
Removed from v.2320  
changed lines
  Added in v.2399